import FlowService from '@/webflow/flow-service'

// 写死一个流程数据并返回
function getDataMock(params) {
  return new Promise((resolve) => {
    resolve({
      instId: 404,
      activeStepId: 404,
      mode: 'EDIT',
      processId: 'G_1_FWGS',
      flowFormModelRelationId: 0,
      processFormData: {
        pageId: 'vue:doc/flowFormExample' + params.scopeId,
        formId: 'entity:oaDocDispatch',
        beanId: '404',
        mode: 'EDIT',
        processFormPropertyValues: [
          {
            name: 'docIdentifier',
            caption: '公文标识',
            dataType: 'string',
            specType: 'XcoaSpec',
            value: null,
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: false,
            required: false,
            readonly: false,
            attr: {
              controlType: 'StringType',
              field: 'docIdentifier',
              mandatory: 'false',
              maxLength: '2000',
            },
            index: 1,
            controlCat: -1,
          },
          {
            name: 'mainSendUnit',
            caption: '主送单位',
            dataType: 'selectperson',
            specType: 'XcoaSpec',
            value: '[{"type":"GROUP","code":"20020","name":"中国慧科集团","attrNames":[]}]',
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: true,
            required: true,
            readonly: false,
            attr: {
              displayValue: '中国慧科集团',
              selectionType: 'GROUP',
              controlType: 'GroupSelectType',
              field: 'mainSendUnit',
              rootId: 'G-1',
              rootName: '中国慧科集团',
              mandatory: 'true',
            },
            index: 2,
            controlCat: -1,
          },
          {
            name: 'numberYear',
            caption: '年份',
            dataType: 'string',
            specType: 'XcoaSpec',
            value: null,
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: false,
            required: false,
            readonly: false,
            attr: {
              controlType: 'StringType',
              field: 'numberYear',
              mandatory: 'false',
              maxLength: '4',
            },
            index: 3,
            controlCat: -1,
          },
          {
            name: 'creationTime',
            caption: '拟稿日期',
            dataType: 'date',
            specType: 'XcoaSpec',
            value: 1603702168132,
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: true,
            required: false,
            readonly: true,
            attr: {
              displayValue: '2020-10-26',
              controlType: 'SignType',
              field: 'creationTime',
              type: 'date',
            },
            index: 4,
            controlCat: -1,
          },
          {
            name: 'docNumber',
            caption: '发文字号',
            dataType: 'string',
            specType: 'XcoaSpec',
            value: null,
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: true,
            required: false,
            readonly: false,
            attr: {
              controlType: 'StringType',
              field: 'docNumber',
              mandatory: 'false',
              maxLength: '100',
            },
            index: 5,
            controlCat: -1,
          },
          {
            name: 'jiontlyOpinion',
            caption: '会签',
            dataType: 'OpinionView',
            specType: 'XcoaSpec',
            value: null,
            defaultValue: null,
            htmlType: null,
            mutable: false,
            idProperty: false,
            mobileVisible: true,
            required: false,
            readonly: true,
            attr: {
              controlType: 'OpinionViewType',
              field: 'jiontlyOpinion',
              dataType: 'opinionView',
              opinions: [],
            },
            index: 6,
            controlCat: -1,
          },
          {
            name: 'dispatchUnit',
            caption: '发文单位',
            dataType: 'string',
            specType: 'XcoaSpec',
            value: '综合部（办公室）',
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: true,
            required: false,
            readonly: true,
            attr: {
              signFieldType: 'name',
              controlType: 'SignType',
              field: 'dispatchUnit',
              type: 'group',
            },
            index: 7,
            controlCat: -1,
          },
          {
            name: 'creatorName',
            caption: '拟稿人',
            dataType: 'string',
            specType: 'XcoaSpec',
            value: '唐纯',
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: true,
            required: false,
            readonly: true,
            attr: {
              signFieldType: 'name',
              controlType: 'SignType',
              field: 'creatorName',
              type: 'user',
            },
            index: 8,
            controlCat: -1,
          },
          {
            name: 'copySendUnit',
            caption: '抄送单位',
            dataType: 'selectperson',
            specType: 'XcoaSpec',
            value: '[]',
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: true,
            required: false,
            readonly: false,
            attr: {
              displayValue: '',
              selectionType: 'GROUP',
              controlType: 'GroupSelectType',
              field: 'copySendUnit',
              rootId: 'G-1',
              rootName: '中国慧科集团',
            },
            index: 9,
            controlCat: -1,
          },
          {
            name: 'copyLeader',
            caption: '抄送领导',
            dataType: 'selectperson',
            specType: 'XcoaSpec',
            value: '[]',
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: true,
            required: false,
            readonly: false,
            attr: {
              displayValue: '',
              selectionType: 'USER',
              controlType: 'GroupSelectType',
              field: 'copyLeader',
              rootId: 'G-1',
              rootName: '中国慧科集团',
            },
            index: 10,
            controlCat: -1,
          },
          {
            name: 'title',
            caption: '标题',
            dataType: 'title',
            specType: 'XcoaSpec',
            value: '测试流程',
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: true,
            required: true,
            readonly: false,
            attr: {
              controlType: 'StringType',
              field: 'title',
              mandatory: 'true',
              maxLength: '100',
            },
            index: 11,
            controlCat: -1,
          },
          {
            name: 'items',
            caption: '物品详情',
            dataType: 'collection',
            attr: {
              dync: [
                {
                  specType: 'hdTextField',
                  dataType: 'string',
                  name: 'name',
                  caption: '名称',
                },
                {
                  specType: 'hdTextField',
                  dataType: 'number',
                  name: 'price',
                  caption: '价格',
                },
              ],
            },
            value: '[{"name": "铅笔","price": 2},{"name": "记事本","price": 5}]',
          },
          {
            name: 'urgencyLevel',
            caption: '缓急',
            dataType: 'selectlist',
            specType: 'XcoaSpec',
            value: '1',
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: true,
            required: true,
            readonly: false,
            attr: {
              displayValue: '加急',
              controlType: 'DictType',
              field: 'urgencyLevel',
              multiple: 'false',
              mandatory: 'true',
              selectListItem: [
                {
                  label: '无',
                  value: '0',
                },
                {
                  label: '加急',
                  value: '1',
                },
                {
                  label: '特急',
                  value: '2',
                },
              ],
            },
            index: 12,
            controlCat: -1,
          },
          {
            name: 'numberWord',
            caption: '代字',
            dataType: 'string',
            specType: 'XcoaSpec',
            value: null,
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: false,
            required: false,
            readonly: false,
            attr: {
              controlType: 'StringType',
              field: 'numberWord',
              mandatory: 'false',
              maxLength: '20',
            },
            index: 13,
            controlCat: -1,
          },
          {
            name: 'relatedDoc',
            caption: '关联文档',
            dataType: 'relateddoc',
            specType: 'XcoaSpec',
            value: 'ec33420cc3574ee5850',
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: false,
            required: false,
            readonly: false,
            attr: {
              relatedDoc: '[]',
              controlType: 'RelatedDocType',
              field: 'relatedDoc',
              readonly: true,
            },
            index: 14,
            controlCat: -1,
          },
          {
            name: 'attachment',
            caption: '正文附件',
            dataType: 'attachment',
            specType: 'XcoaSpec',
            value: '{"value":"61847"}',
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: true,
            required: false,
            readonly: false,
            attr: {
              renamable: false,
              downloadable: true,
              filenameMaxLength: '80',
              attachments: [
                {
                  name: '发函.docx',
                  code: '7683',
                  groupCode: '61847',
                  size: '22.0KB',
                  fileSize: 23118,
                  creationTime: 0,
                  lastModifiedTime: 0,
                  catNum: '-6',
                  attr: null,
                },
                {
                  name: '痕迹稿2_test.doc',
                  code: '8722',
                  groupCode: '61847',
                  size: '179.0KB',
                  fileSize: 183808,
                  creationTime: 0,
                  lastModifiedTime: 0,
                  catNum: '-3',
                  attr: null,
                },
                {
                  name: '痕迹稿1_test.doc',
                  code: '8695',
                  groupCode: '61847',
                  size: '180.0KB',
                  fileSize: 184320,
                  creationTime: 0,
                  lastModifiedTime: 0,
                  catNum: '-3',
                  attr: null,
                },
                {
                  name: 'test.doc',
                  code: '8742',
                  groupCode: '61847',
                  size: '179.0KB',
                  fileSize: 183808,
                  creationTime: 0,
                  lastModifiedTime: 0,
                  catNum: '-1',
                  attr: null,
                },
                {
                  name: '痕迹稿3_test.doc',
                  code: '8736',
                  groupCode: '61847',
                  size: '180.0KB',
                  fileSize: 184320,
                  creationTime: 0,
                  lastModifiedTime: 0,
                  catNum: '-1',
                  attr: null,
                },
              ],
              uploadable: false,
              controlType: 'AttachmentType',
              field: 'attachment',
              editable: false,
              deletable: false,
              maxFileSize: '10',
            },
            index: 15,
            controlCat: -1,
          },
          {
            name: 'businessTypeName',
            caption: '业务类型名称',
            dataType: 'string',
            specType: 'XcoaSpec',
            value: '集团发文',
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: false,
            required: false,
            readonly: false,
            attr: {
              controlType: 'StringType',
              field: 'businessTypeName',
              mandatory: 'false',
            },
            index: 16,
            controlCat: -1,
          },
          {
            name: 'id',
            caption: 'ID',
            dataType: 'id',
            specType: 'XcoaSpec',
            value: 2472,
            defaultValue: null,
            htmlType: null,
            mutable: false,
            idProperty: false,
            mobileVisible: false,
            required: true,
            readonly: true,
            attr: {
              controlType: 'NumberType',
              field: 'id',
              mandatory: 'true',
            },
            index: 17,
            controlCat: -1,
          },
          {
            name: 'issueDate',
            caption: '成文日期',
            dataType: 'date',
            specType: 'XcoaSpec',
            value: 1603702061948,
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: true,
            required: false,
            readonly: true,
            attr: {
              displayValue: '2020-10-26',
              controlType: 'SignType',
              field: 'issueDate',
              type: 'date',
            },
            index: 18,
            controlCat: -1,
          },
          {
            name: 'mainSend',
            caption: '主送语',
            dataType: 'string',
            specType: 'XcoaSpec',
            value: null,
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: false,
            required: false,
            readonly: false,
            attr: {
              controlType: 'StringType',
              field: 'mainSend',
              mandatory: 'false',
              maxLength: '2000',
            },
            index: 19,
            controlCat: -1,
          },
          {
            name: 'issueUserName',
            caption: '签发人',
            dataType: 'string',
            specType: 'XcoaSpec',
            value: '唐纯',
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: true,
            required: false,
            readonly: true,
            attr: {
              signFieldType: 'name',
              controlType: 'SignType',
              field: 'issueUserName',
              type: 'user',
            },
            index: 20,
            controlCat: -1,
          },
          {
            name: 'createDeptName',
            caption: '拟稿处室',
            dataType: 'string',
            specType: 'XcoaSpec',
            value: '综合部（办公室）',
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: true,
            required: false,
            readonly: true,
            attr: {
              signFieldType: 'name',
              controlType: 'SignType',
              field: 'createDeptName',
              type: 'group',
            },
            index: 21,
            controlCat: -1,
          },
          {
            name: 'serialNumber',
            caption: '流水号',
            dataType: 'number',
            specType: 'XcoaSpec',
            value: null,
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: false,
            required: false,
            readonly: false,
            attr: {
              controlType: 'StringType',
              field: 'serialNumber',
              mandatory: 'false',
            },
            index: 22,
            controlCat: -1,
          },
          {
            name: 'docType',
            caption: '公文类型',
            dataType: 'selectlist',
            specType: 'XcoaSpec',
            value: '02',
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: true,
            required: true,
            readonly: false,
            attr: {
              displayValue: '决定',
              controlType: 'DictType',
              field: 'docType',
              multiple: 'false',
              mandatory: 'true',
              selectListItem: [
                {
                  label: '决议',
                  value: '01',
                },
                {
                  label: '决定',
                  value: '02',
                },
                {
                  label: '命令（令）',
                  value: '03',
                },
                {
                  label: '公报',
                  value: '04',
                },
                {
                  label: '公告',
                  value: '05',
                },
                {
                  label: '通告',
                  value: '06',
                },
                {
                  label: '意见',
                  value: '07',
                },
                {
                  label: '通知',
                  value: '08',
                },
                {
                  label: '通报',
                  value: '09',
                },
                {
                  label: '报告',
                  value: '0A',
                },
                {
                  label: '请示',
                  value: '0B',
                },
                {
                  label: '批复',
                  value: '0C',
                },
                {
                  label: '议案',
                  value: '0D',
                },
                {
                  label: '函',
                  value: '0E',
                },
                {
                  label: '纪要',
                  value: '0F',
                },
                {
                  label: '其他',
                  value: '0Z',
                },
              ],
            },
            index: 23,
            controlCat: -1,
          },
          {
            name: 'printDate',
            caption: '印发日期',
            dataType: 'date',
            specType: 'XcoaSpec',
            value: null,
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: true,
            required: false,
            readonly: false,
            attr: {
              controlType: 'DateType',
              field: 'printDate',
              dateFormat: 'yyyy-MM-dd',
              showTime: 'false',
              showDate: 'true',
              mandatory: 'false',
            },
            index: 24,
            controlCat: -1,
          },
          {
            name: 'reviewer',
            caption: '核稿',
            dataType: 'string',
            specType: 'XcoaSpec',
            value: '唐纯',
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: true,
            required: false,
            readonly: true,
            attr: {
              signFieldType: 'name',
              controlType: 'SignType',
              field: 'reviewer',
              type: 'user',
            },
            index: 25,
            controlCat: -1,
          },
          {
            name: 'secretLevel',
            caption: '密级',
            dataType: 'selectlist',
            specType: 'XcoaSpec',
            value: '1',
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: true,
            required: true,
            readonly: false,
            attr: {
              displayValue: '秘密',
              controlType: 'DictType',
              field: 'secretLevel',
              multiple: 'false',
              mandatory: 'true',
              selectListItem: [
                {
                  label: '无',
                  value: '0',
                },
                {
                  label: '秘密',
                  value: '1',
                },
                {
                  label: '机密',
                  value: '2',
                },
                {
                  label: '绝密',
                  value: '3',
                },
              ],
            },
            index: 26,
            controlCat: -1,
          },
          {
            name: 'printCopies',
            caption: '份数',
            dataType: 'number',
            specType: 'XcoaSpec',
            value: null,
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: true,
            required: false,
            readonly: false,
            attr: {
              controlType: 'StringType',
              field: 'printCopies',
              mandatory: 'false',
            },
            index: 27,
            controlCat: -1,
          },
          {
            name: 'businessTypeId',
            caption: '业务类型ID',
            dataType: 'number',
            specType: 'XcoaSpec',
            value: 91,
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: false,
            required: false,
            readonly: false,
            attr: {
              controlType: 'NumberType',
              field: 'businessTypeId',
              mandatory: 'false',
            },
            index: 28,
            controlCat: -1,
          },
          {
            name: 'phoneNumber',
            caption: '联系电话',
            dataType: 'string',
            specType: 'XcoaSpec',
            value: null,
            defaultValue: '1233333',
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: true,
            required: false,
            readonly: false,
            attr: {
              controlType: 'StringType',
              field: 'phoneNumber',
              defaultValue: '1233333',
              mandatory: 'false',
              maxLength: '20',
            },
            index: 29,
            controlCat: -1,
          },
          {
            name: 'issueOpinion',
            caption: '签发',
            dataType: 'OpinionView',
            specType: 'XcoaSpec',
            value: null,
            defaultValue: null,
            htmlType: null,
            mutable: false,
            idProperty: false,
            mobileVisible: true,
            required: false,
            readonly: true,
            attr: {
              controlType: 'OpinionViewType',
              field: 'issueOpinion',
              dataType: 'opinionView',
              opinions: [
                {
                  id: 6936,
                  formId: 'oaDocDispatch',
                  field: 'issueOpinion',
                  beanId: '2472',
                  flowInstanceId: 5238,
                  stepSerialNumber: 4,
                  operator: {
                    type: 'User',
                    code: 'hdadmin',
                    name: '系统管理员',
                    attrs: {
                      signature: '621',
                    },
                  },
                  signer: {
                    userAccount: 'hdadmin',
                    userName: '系统管理员',
                  },
                  signDate: 1603702309216,
                  content: {
                    signContent: '',
                    signUserName: '系统管理员',
                    signDeptName: '系统管理员',
                    signDate: 1603702309216,
                    attrs: {
                      attachment: '61860',
                      attachments: [],
                    },
                  },
                },
              ],
            },
            index: 30,
            controlCat: -1,
          },
          {
            name: 'approveOpinion',
            caption: '意见',
            dataType: 'opinion',
            specType: 'XcoaSpec',
            value: '{"value":{"attrs":{"attachment":"76630"}}}',
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: true,
            required: false,
            readonly: true,
            attr: {
              controlType: 'OpinionType',
              field: 'approveOpinion',
              opinions: [
                {
                  id: 6932,
                  formId: 'oaDocDispatch',
                  field: 'approveOpinion',
                  beanId: '2472',
                  flowInstanceId: 5238,
                  stepSerialNumber: 0,
                  operator: {
                    type: 'User',
                    code: 'tangchun',
                    name: '唐纯',
                    attrs: null,
                  },
                  signer: {
                    userAccount: 'tangchun',
                    userName: '唐纯',
                  },
                  signDate: 1603702168123,
                  content: {
                    signContent: '',
                    signUserName: '唐纯',
                    signDeptName: '综合部（办公室）',
                    signDate: 1603702168123,
                    attrs: {
                      attachment: '61848',
                      attachments: [],
                    },
                  },
                },
                {
                  id: 6933,
                  formId: 'oaDocDispatch',
                  field: 'approveOpinion',
                  beanId: '2472',
                  flowInstanceId: 5238,
                  stepSerialNumber: 1,
                  operator: {
                    type: 'User',
                    code: 'tangchun',
                    name: '唐纯',
                    attrs: null,
                  },
                  signer: {
                    userAccount: 'tangchun',
                    userName: '唐纯',
                  },
                  signDate: 1603702216885,
                  content: {
                    signContent: '',
                    signUserName: '唐纯',
                    signDeptName: '综合部（办公室）',
                    signDate: 1603702216885,
                    attrs: {
                      attachment: '61855',
                      attachments: [],
                    },
                  },
                },
                {
                  id: 6934,
                  formId: 'oaDocDispatch',
                  field: 'approveOpinion',
                  beanId: '2472',
                  flowInstanceId: 5238,
                  stepSerialNumber: 2,
                  operator: {
                    type: 'User',
                    code: 'tangchun',
                    name: '唐纯',
                    attrs: null,
                  },
                  signer: {
                    userAccount: 'tangchun',
                    userName: '唐纯',
                  },
                  signDate: 1603702250202,
                  content: {
                    signContent: '',
                    signUserName: '唐纯',
                    signDeptName: '综合部（办公室）',
                    signDate: 1603702250202,
                    attrs: {
                      attachment: '61857',
                      attachments: [],
                    },
                  },
                },
                {
                  id: 6935,
                  formId: 'oaDocDispatch',
                  field: 'approveOpinion',
                  beanId: '2472',
                  flowInstanceId: 5238,
                  stepSerialNumber: 3,
                  operator: {
                    type: 'User',
                    code: 'hdadmin',
                    name: '系统管理员',
                    attrs: {
                      signature: '621',
                    },
                  },
                  signer: {
                    userAccount: 'hdadmin',
                    userName: '系统管理员',
                  },
                  signDate: 1603702293810,
                  content: {
                    signContent: '',
                    signUserName: '系统管理员',
                    signDeptName: '系统管理员',
                    signDate: 1603702293810,
                    attrs: {
                      attachment: '61858',
                      attachments: [],
                    },
                  },
                },
              ],
            },
            index: 31,
            controlCat: -1,
          },
          {
            name: 'belongedOrgId',
            caption: '所属分级机构ID',
            dataType: 'default',
            specType: 'XcoaSpec',
            value: -1,
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: false,
            required: false,
            readonly: false,
            attr: {
              controlType: 'NumberType',
              field: 'belongedOrgId',
            },
            index: 32,
            controlCat: -1,
          },
          {
            name: 'open',
            caption: '是否公开',
            dataType: 'selectlist',
            specType: 'XcoaSpec',
            value: null,
            defaultValue: '0',
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: true,
            required: false,
            readonly: false,
            attr: {
              controlType: 'DictType',
              field: 'open',
              defaultValue: '0',
              multiple: 'false',
              mandatory: 'false',
              selectListItem: [
                {
                  label: '公开',
                  value: '1',
                },
                {
                  label: '不公开',
                  value: '0',
                },
              ],
            },
            index: 33,
            controlCat: -1,
          },
          {
            name: 'remarks',
            caption: '备注说明',
            dataType: 'string',
            specType: 'XcoaSpec',
            value: null,
            defaultValue: null,
            htmlType: null,
            mutable: true,
            idProperty: false,
            mobileVisible: true,
            required: false,
            readonly: false,
            attr: {
              controlType: 'StringType',
              field: 'remarks',
              mandatory: 'false',
              maxLength: '2000',
            },
            index: 34,
            controlCat: -1,
          },
        ],
      },
      processLogInfo: [
        {
          index: 1,
          operator: '唐纯',
          operatorAccount: 'tangchun',
          opinion: null,
          signDate: 1603702168123,
          finishDate: 1603702169970,
          actionName: '部门领导审核',
          stepName: '拟稿',
          processLogAttachments: [],
          stepSerialNumber: 0,
          subFlowLogInfo: null,
          props: {
            source: 'WE.OFFICE',
            opinionId: '6932',
            stepNameOfSubmit: '拟稿',
            stepIdOfSubmit: 'G_1_FWGS.1',
            stepTypeOfSubmit: '起始',
          },
          instId: 5238,
          actionId: 'G_1_FWGS.1',
          stepId: 'G_1_FWGS.1',
          stepType: '起始',
          trustor: null,
          trustorName: null,
          subInstId: 0,
          processTime: null,
          importOpinion: null,
        },
        {
          index: 2,
          operator: '唐纯',
          operatorAccount: 'tangchun',
          opinion: null,
          signDate: 1603702216885,
          finishDate: 1603702217187,
          actionName: '送起草人',
          stepName: '部门领导审核',
          processLogAttachments: [],
          stepSerialNumber: 1,
          subFlowLogInfo: null,
          props: {
            source: 'WE.OFFICE',
            opinionId: '6933',
            stepNameOfSubmit: '部门领导审核',
            stepIdOfSubmit: 'G_1_FWGS.2',
            stepTypeOfSubmit: '一般',
          },
          instId: 5238,
          actionId: 'G_1_FWGS.2',
          stepId: 'G_1_FWGS.2',
          stepType: '一般',
          trustor: null,
          trustorName: null,
          subInstId: 0,
          processTime: null,
          importOpinion: null,
        },
        {
          index: 3,
          operator: '唐纯',
          operatorAccount: 'tangchun',
          opinion: null,
          signDate: 1603702250202,
          finishDate: 1603702250506,
          actionName: '核稿',
          stepName: '送起草人',
          processLogAttachments: [],
          stepSerialNumber: 2,
          subFlowLogInfo: null,
          props: {
            source: 'WE.OFFICE',
            opinionId: '6934',
            stepNameOfSubmit: '送起草人',
            stepIdOfSubmit: 'G_1_FWGS.3',
            stepTypeOfSubmit: '一般',
          },
          instId: 5238,
          actionId: 'G_1_FWGS.5',
          stepId: 'G_1_FWGS.3',
          stepType: '一般',
          trustor: null,
          trustorName: null,
          subInstId: 0,
          processTime: null,
          importOpinion: null,
        },
        {
          index: 4,
          operator: '系统管理员',
          operatorAccount: 'hdadmin',
          opinion: null,
          signDate: 1603702293810,
          finishDate: 1603702294122,
          actionName: '领导签发',
          stepName: '核稿',
          processLogAttachments: [],
          stepSerialNumber: 3,
          subFlowLogInfo: null,
          props: {
            source: 'WE.OFFICE',
            opinionId: '6935',
            stepNameOfSubmit: '核稿',
            stepIdOfSubmit: 'G_1_FWGS.4',
            stepTypeOfSubmit: '一般',
          },
          instId: 5238,
          actionId: 'G_1_FWGS.6',
          stepId: 'G_1_FWGS.4',
          stepType: '一般',
          trustor: null,
          trustorName: null,
          subInstId: 0,
          processTime: null,
          importOpinion: null,
        },
        {
          index: 5,
          operator: '系统管理员',
          operatorAccount: 'hdadmin',
          opinion: null,
          signDate: 1603702309216,
          finishDate: 1603702309502,
          actionName: '核稿',
          stepName: '领导签发',
          processLogAttachments: [],
          stepSerialNumber: 4,
          subFlowLogInfo: null,
          props: {
            source: 'WE.OFFICE',
            opinionId: '6936',
            stepNameOfSubmit: '领导签发',
            stepIdOfSubmit: 'G_1_FWGS.6',
            stepTypeOfSubmit: '一般',
          },
          instId: 5238,
          actionId: 'G_1_FWGS.7',
          stepId: 'G_1_FWGS.6',
          stepType: '一般',
          trustor: null,
          trustorName: null,
          subInstId: 0,
          processTime: null,
          importOpinion: null,
        },
      ],
      communicationLogInfo: [],
      informLogInfo: [],
      reminderLogInfo: [],
      lockId: 0,
      buttons: [
        {
          buttonId: 'we-doc$print',
          buttonName: '打印',
        },
        {
          buttonId: 'we-doc$close',
          buttonName: '退出',
        },
        {
          buttonId: 'workflow$inform',
          buttonName: '知会',
          attrs: null,
          rollbackSteps: null,
        },
        {
          buttonId: 'workflow$turnToDo',
          buttonName: '转办',
          attrs: null,
          rollbackSteps: null,
        },
        {
          buttonId: 'workflow$comm',
          buttonName: '沟通',
          attrs: null,
          rollbackSteps: null,
        },
        {
          buttonId: 'workflow$interfere',
          buttonName: '驳回',
          attrs: null,
          rollbackSteps: [
            {
              historyStepId: 9671,
              historyStepName: '开始',
              userAccount: 'hdadmin',
              userName: '系统管理员',
            },
          ],
        },
      ],
      saveButtons: [
        {
          buttonId: 'save_G_1_FWGS.4',
          buttonName: '保存',
          attrs: null,
          rollbackSteps: null,
        },
      ],
      pushButtons: [
        {
          buttonId: 'G_1_FWGS.6',
          buttonName: '领导签发',
          attrs: null,
          rollbackSteps: null,
        },
        {
          buttonId: 'G_1_FWGS.8',
          buttonName: '文书',
          attrs: null,
          rollbackSteps: null,
        },
      ],
      processActiveLogInfo: [
        {
          index: 1,
          operator: '系统管理员',
          operatorCode: 'hdadmin',
          operatorType: 'User',
          status: '处理中',
          stepName: '核稿',
          users: [
            {
              account: 'hdadmin',
              name: '系统管理员',
            },
          ],
        },
      ],
      opinions: [
        {
          id: 6932,
          formId: 'oaDocDispatch',
          field: 'approveOpinion',
          beanId: '2472',
          flowInstanceId: 5238,
          stepSerialNumber: 0,
          operator: {
            type: 'User',
            code: 'tangchun',
            name: '唐纯',
            attrs: null,
            attrNames: [],
          },
          signer: {
            account: 'tangchun',
            name: '唐纯',
          },
          signDate: 1603702168123,
          content: {
            signContent: '',
            signUserName: '唐纯',
            signDeptName: '综合部（办公室）',
            signDate: 1603702168123,
            attrs: {
              attachment: '61848',
            },
          },
          opinionType: 0,
          props: null,
        },
        {
          id: 6933,
          formId: 'oaDocDispatch',
          field: 'approveOpinion',
          beanId: '2472',
          flowInstanceId: 5238,
          stepSerialNumber: 1,
          operator: {
            type: 'User',
            code: 'tangchun',
            name: '唐纯',
            attrs: null,
            attrNames: [],
          },
          signer: {
            account: 'tangchun',
            name: '唐纯',
          },
          signDate: 1603702216885,
          content: {
            signContent: '',
            signUserName: '唐纯',
            signDeptName: '综合部（办公室）',
            signDate: 1603702216885,
            attrs: {
              attachment: '61855',
            },
          },
          opinionType: 0,
          props: null,
        },
        {
          id: 6934,
          formId: 'oaDocDispatch',
          field: 'approveOpinion',
          beanId: '2472',
          flowInstanceId: 5238,
          stepSerialNumber: 2,
          operator: {
            type: 'User',
            code: 'tangchun',
            name: '唐纯',
            attrs: null,
            attrNames: [],
          },
          signer: {
            account: 'tangchun',
            name: '唐纯',
          },
          signDate: 1603702250202,
          content: {
            signContent: '',
            signUserName: '唐纯',
            signDeptName: '综合部（办公室）',
            signDate: 1603702250202,
            attrs: {
              attachment: '61857',
            },
          },
          opinionType: 0,
          props: null,
        },
        {
          id: 6935,
          formId: 'oaDocDispatch',
          field: 'approveOpinion',
          beanId: '2472',
          flowInstanceId: 5238,
          stepSerialNumber: 3,
          operator: {
            type: 'User',
            code: 'hdadmin',
            name: '系统管理员',
            attrs: null,
            attrNames: [],
          },
          signer: {
            account: 'hdadmin',
            name: '系统管理员',
          },
          signDate: 1603702293810,
          content: {
            signContent: '',
            signUserName: '系统管理员',
            signDeptName: '系统管理员',
            signDate: 1603702293810,
            attrs: {
              attachment: '61858',
            },
          },
          opinionType: 0,
          props: null,
        },
        {
          id: 6936,
          formId: 'oaDocDispatch',
          field: 'issueOpinion',
          beanId: '2472',
          flowInstanceId: 5238,
          stepSerialNumber: 4,
          operator: {
            type: 'User',
            code: 'hdadmin',
            name: '系统管理员',
            attrs: null,
            attrNames: [],
          },
          signer: {
            account: 'hdadmin',
            name: '系统管理员',
          },
          signDate: 1603702309216,
          content: {
            signContent: '',
            signUserName: '系统管理员',
            signDeptName: '系统管理员',
            signDate: 1603702309216,
            attrs: {
              attachment: '61860',
            },
          },
          opinionType: 0,
          props: null,
        },
      ],
      remindOpinions: [],
      communicationOpinions: [],
      attrs: {
        isSubflow: false,
        workflowStatus: 'ACTIVATED',
        'we-doc$changeFileFormat': 'true',
        'we-doc$redheader': 'true',
        stepN: 5,
        'we-doc$cleanCopy': 'true',
        'we-doc$putSealOn': 'true',
        auditElement: [],
      },
      optimistic: true,
      pageTitle: '表单样例（操作按钮点击会报错）',
      rollbackType: ['workflow$interfere', 'workflow$return_interfere'],
      rollbackSteps: [
        {
          historyStepId: 7841,
          historyStepName: '领导签发',
          userAccount: 'hdadmin',
          userName: '系统管理员',
        },
        {
          historyStepId: 7839,
          historyStepName: '送起草人',
          userAccount: 'tangchun',
          userName: '唐纯',
        },
        {
          historyStepId: 7838,
          historyStepName: '部门领导审核',
          userAccount: 'tangchun',
          userName: '唐纯',
        },
        {
          historyStepId: 7837,
          historyStepName: '拟稿',
          userAccount: 'tangchun',
          userName: '唐纯',
        },
      ],
    })
  })
}

FlowService.getData = getDataMock
