```vue
<template>
  <sd-detail-form
    v-if="beanId"
    :record-id="beanId"
    page-id="base/businesstype/oaBaseBusinessType"
    @saved="saved"
  >
    <sd-form-item name="businessTypeName" />
    <sd-form-item name="status"> </sd-form-item>
  </sd-detail-form>
</template>

<script>
import { Modal } from 'ant-design-vue'
import axios from '@/common/services/axios-instance'

export default {
  data() {
    return {
      beanId: null,
    }
  },
  methods: {
    saved(data) {
      Modal.confirm({
        title: data.pageTitle,
        content: '已保存',
      })
    },
  },
  created() {
    // 为了演示，这里取出第一条文档
    axios({
      url: 'api/framework/v1/page/businessList',
      method: 'post',
      data: { columns: '', maxResults: 1, startPosition: 0, formId: 'oaBaseBusinessType' },
    }).then((res) => {
      this.beanId = res.data.data[0].id
    })
  },
}
</script>
```
