各种组件都可以排序，自动检测横向/纵向

```vue
<template>
  <div>
    <div class="ant-list ant-list-split ant-list-bordered">
      <sd-draggable v-model="data" tag="ul" class="ant-list-items" @update="onSort">
        <a-list-item v-for="element in data" :key="element">
          {{ element }}
        </a-list-item>
      </sd-draggable>
    </div>
    <br />
    <a-card title="知名大学" bordered>
      <sd-draggable v-model="data" @update="onSort">
        <a-card-grid v-for="element in data" :key="element">
          {{ element }}
        </a-card-grid>
      </sd-draggable>
    </a-card>
    <br />
    排序后的数据：{{ data }}
  </div>
</template>

<script>
export default {
  data() {
    return {
      data: ['清华大学', '北京大学', '北京航空航天大学'],
    }
  },
  methods: {
    onSort(evt) {
      // update 事件里面可以被拖拽条目 获取排序前后的索引。
      // 一般不需要用这个事件，直接用 v-model 绑定排序后的数组更方便
      console.log(evt.newIndex, evt.oldIndex)
    },
  },
}
</script>
```
