/**
 * 表格中的操作按钮类型
 * @readonly
 * @enum {string|object}
 */
const TableActionTypes = {
  /** 主要按钮，高亮显示 */
  primary: 'primary',
  /** 批处理按钮，与复选框联动 */
  batch: 'batch',
  /** 行内显示 */
  inline: 'inline',
  /** 已废弃，请使用TableActionTypes.ex */
  oa: {
    /** 删除按钮，自动处理删除逻辑 */
    delete: 'delete',
    /** 新建按钮，自动处理新建逻辑 */
    create: 'create',
  },
  /** sd-data-table-ex特有的类型 */
  ex: {
    /** 删除按钮，自动处理删除逻辑 */
    delete: 'delete',
    /** 新建按钮，自动处理新建逻辑 */
    create: 'create',
  },
}

export default TableActionTypes
