import flowService from '@/webflow/flow-service'
import routerService from '@/common/services/router-service'
import '../core/css/iam-audit-custom.scss'
import asyncComponent from '@/common/services/async-component'

flowService.addFlowForm('vue:audit/plan/iamAuditPlan', './plan/audit-plan-form.vue')
flowService.addFlowForm(
  'vue:audit/planchange/iamAuditProjectChange',
  './plan/audit-planchange-form.vue'
)
flowService.addFlowForm(
  'vue:audit/work/projectmanage/comdocument/iamAuditComdocument',
  './work/projectmanage/comdocument/audit-comdocument-form.vue'
)

flowService.addFlowForm(
  'vue:audit/work/report/iamAuditReport',
  './work/report/report/iam-audit-report-form.vue'
)
// 报告统计-年度计划完成情况
routerService.routeInFrame('audit-report-annualplancompletion', {
  component: './work/report/analyse/iam-audit-report-annualplancompletion',
})

// 报告统计-年度计划完成情况-项目列表
routerService.routeInFrame('audit-annualplancompletion-project-list', {
  component: './work/report/analyse/iam-audit-project-list.vue',
})

// 报告统计-问题涉及金额统计-审计发现列表
routerService.routeInFrame('audit-problemamount-find-list', {
  component: './work/report/analyse/iam-audit-find-list.vue',
})

// 报告统计-项目趋势
routerService.routeInFrame('audit-report-projecttrends', {
  component: './work/report/analyse/iam-audit-report-projecttrends',
})

// 报告统计-问题金额趋势
routerService.routeInFrame('audit-report-problemamount', {
  component: './work/report/analyse/iam-audit-report-problemamount',
})

// 报告统计-问题分析趋势
routerService.routeInFrame('audit-report-problemtrends', {
  component: './work/report/analyse/iam-audit-report-problemtrends',
})

// 审计作业维护-审计报告列表
routerService.routeInFrame('audit-report-list', {
  component: './work/report/audit-report-list.vue',
})

// 审计作业维护-审计发现表单
routerService.routeInFrame('audit-report-find-form', {
  component: './work/report/find/iam-audit-find-form.vue',
})

// 审计作业维护-审计建议与风险表单
routerService.routeInFrame('xm-audit-report-find-form', {
  component: './work/report/find/xm-audit-find-form.vue',
})

// 审计计划维护-审计计划列表
routerService.routeInFrame('audit-plan-list', {
  component: './plan/audit-plan-list.vue',
})

// 审计计划跟踪主页面
routerService.routeInFrame('iam-audit-plan-tracking', {
  component: './plantracking/iam-audit-plan-tracking-view.vue',
})

// 审计作业管理-审计项目列表
routerService.routeInFrame('audit-project-list', {
  component: './project/audit-project-list.vue',
})

// 审计作业管理-审计项目详情
routerService.route('/audit-project-detail', {
  component: './project/audit-project-detail.vue',
})

// 审计作业管理-审计项目启动页面
routerService.route('/audit-project-start-form', {
  component: './project/audit-project-start-form.vue',
})

// 审计作业管理-审计项目评价页面
routerService.route('/audit-project-score', {
  component: './project/audit-project-score.vue',
})

// 门户-友情链接
routerService.routeInFrame('audit-portal-blogroll-list', {
  component: './portal/blogroll/audit-portal-blogroll-list.vue',
})

// 门户-友情链接表单
routerService.route('/audit-portal-blogroll-form/', {
  component: asyncComponent(() =>
    import(
      /* webpackChunkName: "product-iam-audit" */ './portal/blogroll/audit-portal-blogroll-form.vue'
    )
  ),
})

// 审计工作-审计资料
routerService.route('/audit-work/', {
  component: './work/iam-audit-work.vue',
  children: [
    {
      path: 'iam-work-survey-list',
      components: {
        rightfrm: asyncComponent(() => import('./survey/iam-work-survey-list.vue')),
      },
    },
    {
      path: 'iam-audit-preparation-list',
      components: {
        rightfrm: asyncComponent(() => import('./work/preparation/iam-audit-preparation-list.vue')),
      },
    },
    {
      path: 'iam-audit-frame',
      components: {
        rightfrm: asyncComponent(() => import('./work/preparation/frame/iam-audit-frame.vue')),
      },
    },
    {
      path: 'iam-audit-scheme-list',
      components: {
        rightfrm: asyncComponent(() => import('./work/scheme/iam-audit-scheme-list.vue')),
      },
    },
    {
      path: 'audit-notice-list',
      components: {
        rightfrm: asyncComponent(() => import('./notice/audit-notice-list.vue')),
      },
    },
    {
      path: 'iam-audit-into-meeting',
      components: {
        rightfrm: asyncComponent(() =>
          import('./work/preparation/intomeeting/iam-audit-into-meeting.vue')
        ),
      },
    },
    {
      path: 'audit-evidence-list',
      components: {
        rightfrm: asyncComponent(() => import('./evidence/audit-evidence-list.vue')),
      },
    },
    {
      path: 'audit-operate-paper-list',
      components: {
        rightfrm: asyncComponent(() => import('./work/operate/paper/audit-operate-paper-list.vue')),
      },
    },
    {
      path: 'audit-operate-factconfirm-list',
      components: {
        rightfrm: asyncComponent(() =>
          import('./work/operate/factconfirm/audit-factconfirm-list.vue')
        ),
      },
    },
    {
      path: 'iam-audit-leavemeeting',
      components: {
        rightfrm: asyncComponent(() => import('./work/leavemeeting/iam-audit-leavemeeting.vue')),
      },
    },
    {
      path: 'audit-report-list',
      components: {
        rightfrm: asyncComponent(() => import('./work/report/audit-report-list.vue')),
      },
    },
    {
      path: 'audit-projectmanage-list',
      component: asyncComponent(() => import('./work/projectmanage/audit-projectmanage-list.vue')),
    },
    {
      path: 'audit-projectoverview-form',
      component: asyncComponent(() =>
        import('./work/projectoverview/audit-projectoverview-form.vue')
      ),
    },
    {
      path: 'audit-projectuser-list',
      component: asyncComponent(() => import('./work/projectuser/audit-projectuser-list.vue')),
    },
    {
      path: 'audit-projectchange-form',
      component: asyncComponent(() => import('./work/projectchange/audit-projectchange-form.vue')),
    },
    {
      path: 'audit-projectnode-form',
      component: asyncComponent(() => import('./work/projectnode/audit-projectnode-form.vue')),
    },
    {
      path: 'audit-projectcost-list',
      component: asyncComponent(() => import('./work/projectcost/audit-projectcost-list.vue')),
    },
    {
      // 远程审计 zhangtt 20230906
      path: 'xm-audit-preparation-list',
      component: asyncComponent(() => import('./work/preparation/iam-audit-preparation-list.vue')),
    },
    {
      // 审计通知书 zhangtt 20230906
      path: 'xm-audit-notice-list',
      component: asyncComponent(() => import('./notice/audit-notice-list.vue')),
    },
    {
      // 审计项目成果物 zhangtt 20230906
      path: 'xm-audit-report-list',
      component: asyncComponent(() => import('./work/report/audit-report-list.vue')),
    },
    {
      // 项目考评
      path: 'audit-projectscore-form',
      component: asyncComponent(() => import('./work/projectscore/audit-projectscore-form.vue')),
    },
    {
      path: 'audit-project-detail',
      component: asyncComponent(() => import('./project/audit-project-detail.vue')),
    },
  ],
})

// 审计工作-项目台账表单
routerService.route('/audit-account-form/', {
  component: './work/projectmanage/account/audit-account-form.vue',
})

// 审计工作-审计资料申请单
flowService.addFlowForm(
  'vue:audit/work/means/iamAuditWorkAuditMeans',
  './work/apply/iam-audit-work-apply.vue'
)

routerService.route('/sd-frame').child('km-knowledage-base', {
  component: './auditsource/km/knowledge-base/km-knowledage-base.vue',
})

routerService.route('/km-knowledage-form', {
  component: './auditsource/km/knowledge-base/km-knowledage-form.vue',
})

routerService.routeInFrame('km-knowledge-category', {
  component: './auditsource/km/config-center/km-knowledge-category.vue',
})

// 知识库---知识查看
routerService.routeInFrame('km-knowledage-view', {
  component: './auditsource/km/knowledge-base/km-knowledage-view.vue',
})

// 审计资源-审计模板库列表
routerService.routeInFrame('audit-template-list', {
  component: './template/audit-template-list.vue',
})
// 审计资源-审计模板库表单
routerService.routeInFrame('audit-template-form', {
  component: './template/audit-template-form.vue',
})

// 审计综合管理-审计资讯表单
flowService.addFlowForm(
  'vue:audit/information/iamAuditInformation',
  './information/audit-information-form.vue'
)
// 审计综合管理-审计资讯列表
routerService.routeInFrame('audit-information-list', {
  component: './information/audit-information-list.vue',
})

// 用户操作日志列表
routerService.routeInFrame('iam-operator-log-list', {
  component: './operationLog/xm-operation-log-list.vue',
})
// 用户操作统计列表
routerService.routeInFrame('iam-operator-statistics-list', {
  component: './operationLog/xm-operation-statistics.vue',
})

routerService.routeInFrame('equity-penetration-chart', {
  component: './spic-equity-penetration-chart/equity-penetration-chart.vue',
})

// 地址树测试页面
routerService.routeInFrame('audit-tree', {
  component: './work/test-tree.vue',
})

// 审计指引-审计事项
routerService.routeInFrame('audit-matters-form', {
  component: './matters/audit-matters-form.vue',
})
// 审计指引-审计事项列表
routerService.routeInFrame('audit-matters-list', {
  component: './matters/audit-matters-list.vue',
})
// 审计指引-审计事项分类
routerService.routeInFrame('audit-matters-catalog', {
  component: './matters/audit-matters-catalog.vue',
})
// 审计指引-审计事项模板
routerService.routeInFrame('audit-matters-template-list', {
  component: './matters/template/audit-matters-template-list.vue',
})
routerService.routeInFrame('audit-matters-template-form', {
  component: './matters/template/audit-matters-template-form.vue',
})

// 审计资源-审计人员库列表
routerService.routeInFrame('iam-audit-userbase-list', {
  component: './auditsource/userbase/iam-audit-userbase-list.vue',
})
// 审计资源-审计人员库表单
routerService.routeInFrame('iam-audit-userbase-form', {
  component: './auditsource/userbase/iam-audit-userbase-form.vue',
})

// 审计系统配置-作业节点维护列表
routerService.routeInFrame('audit-worknode-list', {
  component: './node/worknode/audit-worknode-list.vue',
})

// 审计系统配置-作业节点维护表单
routerService.routeInFrame('audit-worknode-form', {
  component: './node/worknode/audit-worknode-form.vue',
})

// 审计系统配置-作业流程维护列表
routerService.routeInFrame('audit-workflow-list', {
  component: './node/workflow/audit-workflow-list.vue',
})

// 审计系统配置-作业流程维护表单
routerService.routeInFrame('audit-workflow-form', {
  component: './node/workflow/audit-workflow-form.vue',
})

// 审计资源-外聘机构库列表
routerService.routeInFrame('iam-audit-extrnal-list', {
  component: './auditsource/extrnal/iam-audit-extrnal-list.vue',
})
// 审计资源-外聘机构库表单
routerService.routeInFrame('iam-audit-extrnal-form', {
  component: './auditsource/extrnal/iam-audit-extrnal-form.vue',
})

// 审计资源-审计人员库表单
routerService.routeInFrame('test-tree-table', {
  component: './work/test-tree-table',
})
// 审计资源-审计人员库表单
routerService.routeInFrame('test-tree', {
  component: './work/test-tree',
})

// 审计资源-审计问题分类
routerService.routeInFrame('iam-source-problem-category', {
  component: './auditsource/problem/iam-source-problem-category.vue',
})

// 审计资源-审计问题列表
routerService.routeInFrame('iam-source-problem-list', {
  component: './auditsource/problem/iam-source-problem-list.vue',
})

// 审计资源-审计问题表单
routerService.routeInFrame('iam-source-problem-form', {
  component: './auditsource/problem/iam-source-problem-form.vue',
})

// 审计事项树测试页面
routerService.routeInFrame('audit-matters-tree', {
  component: './matters/template/audit-matters-tree.vue',
})

// 审计事项树测试页面
routerService.routeInFrame('test-modal', {
  component: './work/test-modal',
})

// 审计资源-审计对象列表
routerService.routeInFrame('iam-source-target-list', {
  component: './auditsource/target/iam-source-target-list.vue',
})

// 审计资源-审计对象列表
routerService.routeInFrame('iam-source-target-form', {
  component: './auditsource/target/iam-source-target-form.vue',
})

// 审计作业-准备阶段-审计通知书表单
flowService.addFlowForm('vue:audit/notice/iamAuditNotice', './notice/audit-notice-form.vue')

// 审计作业-准备阶段-审计通知书列表
routerService.routeInFrame('audit-notice-list', {
  component: './notice/audit-notice-list.vue',
})
// 审计作业-准备阶段-审计调查
routerService.routeInFrame('iam-work-survey-list', {
  component: './survey/iam-work-survey-list.vue',
})
// 审计作业-准备阶段-审计调查表单
routerService.routeInFrame('iam-work-survey-form', {
  component: './survey/iam-work-survey-form.vue',
})

// 审计作业-实施阶段-审计取证表单
routerService.routeInFrame('audit-evidence-from', {
  component: './evidence/audit-evidence-from.vue',
})

// 审计作业-实施阶段-审计取证列表
routerService.routeInFrame('audit-evidence-list', {
  component: './evidence/audit-evidence-list.vue',
})

// 审计作业-准备阶段-审计方案
flowService.addFlowForm(
  'vue:audit/work/scheme/iamAuditScheme',
  './work/scheme/iam-audit-scheme-form.vue'
)

// 审计作业-准备阶段-审计方案列表
routerService.routeInFrame('iam-audit-scheme-list', {
  component: './work/scheme/iam-audit-scheme-list.vue',
})
// 审计作业-实施阶段-审计资料主列表
routerService.routeInFrame('iam-audit-preparation-list', {
  component: './work/preparation/iam-audit-preparation-list.vue',
})
// 审计作业-准备阶段-审计资料表单
routerService.routeInFrame('iam-audit-material-from', {
  component: './work/preparation/material/iam-audit-material-form.vue',
})
// 审计作业-准备阶段-审前资料清单
flowService.addFlowForm(
  'vue:audit/preparation/materialList/iamAuditMaterialList',
  './work/preparation/materialList/iam-audit-material-list-form.vue'
)

// 审计作业-项目管理列表
routerService.routeInFrame('audit-projectmanage-list', {
  component: asyncComponent(() =>
    import(
      /* webpackChunkName: "product-iam-audit" */ './work/projectmanage/audit-projectmanage-list.vue'
    )
  ),
})

// 审计作业-项目概况表单
routerService.routeInFrame('audit-projectoverview-form', {
  component: './work/projectoverview/audit-projectoverview-form.vue',
})
// 审计作业-项目成员列表
routerService.routeInFrame('audit-projectuser-list', {
  component: './work/projectuser/audit-projectuser-list.vue',
})

// 审计作业-项目变更表单
routerService.routeInFrame('audit-projectchange-form', {
  component: './work/projectchange/audit-projectchange-form.vue',
})

// 审计作业-项目节点表单
routerService.routeInFrame('audit-projectnode-form', {
  component: './work/projectnode/audit-projectnode-form.vue',
})

// 审计作业-项目费用列表
routerService.routeInFrame('audit-projectcost-list', {
  component: './work/projectcost/audit-projectcost-list.vue',
})

// 审计作业-项目费用表单
routerService.routeInFrame('audit-projectcost-form', {
  component: './work/projectcost/audit-projectcost-form.vue',
})

// 审计作业-实施阶段-审计取证表单
routerService.routeInFrame('iam-audit-material-from', {
  component: './work/preparation/material/iam-audit-material-form.vue',
})

// 审计作业-实施-工作底稿
flowService.addFlowForm(
  'vue:audit/work/operate/paper/iamWorkPaper',
  './work/operate/paper/iam-operate-paper-form.vue'
)
// 审计作业-实施-工作底稿
routerService.routeInFrame('iam-operate-paper-form', {
  component: './work/operate/paper/iam-operate-paper-form.vue',
})
// 审计作业-实施-工作底稿列表
routerService.routeInFrame('audit-operate-paper-list', {
  component: './work/operate/paper/audit-operate-paper-list.vue',
})

// 审计作业-实施-事实确认
routerService.routeInFrame('iam-operate-factconfirm-form', {
  component: './work/operate/factconfirm/audit-factconfirm-form.vue',
})
// 审计作业-实施-事实确认列表
routerService.routeInFrame('audit-operate-factconfirm-list', {
  component: './work/operate/factconfirm/audit-factconfirm-list.vue',
})

// 审计作业-准备阶段-审计资料表单
routerService.routeInFrame('iam-operate-find-form', {
  component: './work/operate/find/iam-operate-find-form.vue',
})

routerService.routeInFrame('iam-operate-find-detail-form', {
  component: './work/operate/find/iam-operate-find-detail-form.vue',
})

// 审计档案管理-档案借阅表单
flowService.addFlowForm('vue:audit/borrow/iamArchivesBorrow', './borrow/audit-borrow-form.vue')

// 审计档案管理-档案借阅列表
routerService.routeInFrame('audit-borrow-list', {
  component: './borrow/audit-borrow-list.vue',
})

// 审计档案管理-查看档案信息
routerService.routeInFrame('audit-archives-view', {
  component: './borrow/audit-archives-view.vue',
})

// 审计档案管理-档案维护列表
routerService.routeInFrame('audit-archives-list', {
  component: './archives/audit-archives-list.vue',
})

// 审计档案管理-档案维护表单
routerService.routeInFrame('audit-archives-form', {
  component: './archives/audit-archives-form.vue',
})

// 审计档案管理-案卷资料列表
routerService.routeInFrame('audit-dossier-list', {
  component: './archives/audit-dossier-list.vue',
})

// 审计档案管理-案卷资料表单
routerService.routeInFrame('audit-dossier-form', {
  component: './archives/audit-dossier-form.vue',
})

// 审计档案管理-归档目录配置列表
routerService.routeInFrame('audit-deploy-list', {
  component: './deploy/audit-deploy-list.vue',
})

// 审计档案管理-归档目录配置表单
routerService.routeInFrame('audit-deploy-form', {
  component: './deploy/audit-deploy-form.vue',
})

// 审计模型管理-审计模型列表
routerService.routeInFrame('audit-maintain-list', {
  component: './maintain/audit-maintain-list.vue',
})
// 审计模型管理-日志查看列表
routerService.routeInFrame('audit-maintain-log-list', {
  component: './maintain/audit-maintain-log-list.vue',
})
// 审计指引-审计模型分类
routerService.routeInFrame('audit-maintain-catalog', {
  component: './maintain/audit-maintain-catalog.vue',
})

// 审计模型管理-审计模型表单
routerService.routeInFrame('audit-maintain-from', {
  component: './maintain/audit-maintain-from.vue',
})

// 审计模型管理-模型授权表单
routerService.routeInFrame('audit-warrant-from', {
  component: './maintain/audit-warrant-from.vue',
})
// 审计模型管理-模型授权详情
routerService.routeInFrame('audit-warrant-readonly', {
  component: './maintain/audit-warrant-readonly.vue',
})
// 审计模型管理-模型领域列表 area
routerService.routeInFrame('audit-area-list', {
  component: './maintain/audit-area-list.vue',
})
// 审计模型管理-模型领域人员绑定
routerService.routeInFrame('audit-bind-people', {
  component: './maintain/audit-bind-people.vue',
})
// 审计模型管理-模型阶段列表
routerService.routeInFrame('audit-stage-list', {
  component: './maintain/audit-stage-list.vue',
})

// 审计模型管理-数据授权表单
routerService.routeInFrame('audit-deptdatawarrant-from', {
  component: './maintain/audit-deptdatawarrant-from.vue',
})
// 审计模型管理-事件标签列表
routerService.routeInFrame('audit-event-tag-list', {
  component: './maintain/audit-event-tag-list.vue',
})
// 审计模型表单-事件标签
routerService.routeInFrame('audit-event-tag-from', {
  component: './maintain/audit-event-tag-from.vue',
})
// 消息通知
routerService.routeInFrame('audit-message-list', {
  component: './maintain/audit-message-list.vue',
})

// 审计模型管理-模型查询列表
routerService.routeInFrame('audit-view-list', {
  component: './maintain/audit-view-list.vue',
})
// 审计模型管理-引用模型排行
routerService.routeInFrame('audit-maintain-quote-list', {
  component: './maintain/audit-maintain-quote-list.vue',
})

// 审计模型管理-数据授权申请表单
flowService.addFlowForm('vue:audit/sqapply/iamAuditSqapply', './dataUphold/audit-sqapply-from.vue')

// 审计模型管理-模型授权申请表单
flowService.addFlowForm(
  'vue:audit/sqapply/iamModelAuditSqapply',
  './maintain/audit-sqapply-from.vue'
)

// 审计模型管理-授权申请列表
routerService.routeInFrame('audit-sqapply-list', {
  component: './maintain/audit-sqapply-list.vue',
})

// 审计模型管理-模型授权记录
routerService.routeInFrame('audit-record-list', {
  component: './maintain/audit-record-list.vue',
})

// 审计风险库-审计问题总汇查询列表
routerService.routeInFrame('audit-summarry-list', {
  component: './riskLibrary/audit-summarry-list.vue',
})
// 审计风险库领导部分
routerService.routeInFrame('audit-summarry-comp', {
  component: './riskLibrary/audit-summarry-list.vue',
})
// 审计风险库-审计问题总汇-关注类查询列表
routerService.routeInFrame('audit-summarry-interest-list', {
  component: './riskLibrary/audit-summarry-interest-list.vue',
})
// 审计风险库-审计问题总汇-整改类查询列表
routerService.routeInFrame('audit-summarry-rectification-list', {
  component: './riskLibrary/audit-summarry-rectification-list.vue',
})
// 审计风险库-审计问题总汇审核
routerService.routeInFrame('audit-shsum-list', {
  component: './riskLibrary/audit-shsum-list.vue',
}) // 审计风险库-审计问题整改审核
routerService.routeInFrame('audit-shchange-list', {
  component: './riskLibrary/audit-shchange-list.vue',
}) // 审计风险库-审计问题关注审核
routerService.routeInFrame('audit-shdetail-list', {
  component: './riskLibrary/audit-shdetail-list.vue',
})
// 主数据管理-字段绑定
routerService.routeInFrame('masterdata-field-binding', {
  component: './masterdata/masterdata-field-binding.vue',
})

// 审计风险库-非问题说明
routerService.routeInFrame('audit-false-problem', {
  component: './maintain/audit-false-problem.vue',
})

// 数据维护-数据分类维护
routerService.routeInFrame('audit-data-class', {
  component: './dataUphold/audit-data-class.vue',
})

// 数据维护-数据授权记录
routerService.routeInFrame('audit-data-empower-record', {
  component: './dataUphold/audit-data-empower-record',
})

// 数据维护-数据授权记录详情
routerService.routeInFrame('audit-data-empower-info', {
  component: './dataUphold/audit-data-empower-info.vue',
})

// 数据维护-数据查询
routerService.routeInFrame('audit-data-list', {
  component: './dataUphold/audit-data-list',
})

// 数据维护-授权申请
routerService.routeInFrame('audit-data-apply', {
  component: './dataUphold/audit-data-apply',
})

// 数据维护-授权申请表单
routerService.routeInFrame('audit-data-from', {
  component: './dataUphold/audit-data-from.vue',
})
// 索引列表
routerService.routeInFrame('audit-class-index', {
  component: './dataUphold/audit-class-index.vue',
})
// 审计框架主页面
routerService.routeInFrame('iam-audit-frame', {
  component: './work/preparation/frame/iam-audit-frame.vue',
})
// 审计框架主页面
routerService.routeInFrame('iam-audit-frame-item', {
  component: './work/preparation/frame/item/iam-audit-frame-item-create.vue',
})
// 外部项目管理列表
routerService.routeInFrame('audit-externalProject-list', {
  component: './externalProject/iam-audit-external-project.vue',
})
// 外部项目管理新增修改页面
routerService.routeInFrame('audit-externalProject-form', {
  component: './externalProject/iam-audit-external-project-form.vue',
})
// 外部项目管理-审计发现表单
routerService.routeInFrame('audit-externalProject-find-form', {
  component: './externalProject/find/iam-audit-external-project-find-form.vue',
})

// 离场会
routerService.routeInFrame('iam-audit-leavemeeting', {
  component: './work/leavemeeting/iam-audit-leavemeeting.vue',
})
routerService.routeInFrame('iam-audit-leavemeeting-form', {
  component: './work/leavemeeting/iam-audit-leavemeeting-form.vue',
})
// 进场会
routerService.routeInFrame('iam-audit-into-meeting', {
  component: './work/preparation/intomeeting/iam-audit-into-meeting.vue',
})
routerService.routeInFrame('iam-audit-into-meeting-form', {
  component: './work/preparation/intomeeting/iam-audit-into-meeting-form.vue',
})

// 整改计划申请单
flowService.addFlowForm(
  'vue:audit/rectPlanProject/iamWorkRectProject',
  './rectplanproject/audit-rectplanproject-form.vue'
)

routerService.routeInFrame('audit-rectfind-form', {
  component: './rectplanproject/audit-rectfind-form.vue',
})

// 整改计划项目列表
routerService.routeInFrame('audit-rectplanproject-list', {
  component: './rectplanproject/audit-rectplanproject-list.vue',
})

// 整改反馈单
flowService.addFlowForm(
  'vue:audit/rectFeedback/iamWorkRectFeedback',
  './rectfeedback/audit-rectfeedback-form.vue'
)

// 整改反馈列表
routerService.routeInFrame('audit-rectfeedback-list', {
  component: './rectfeedback/audit-rectfeedback-list.vue',
})

// 整改问题清单列表
routerService.routeInFrame('audit-question-list', {
  component: './question/audit-question-list.vue',
})

// 整改问题清单表单
routerService.routeInFrame('audit-question-form', {
  component: './question/audit-question-form.vue',
})
// 整改问题清单-反馈单
routerService.routeInFrame('audit-question-feedback-form', {
  component: './question/audit-feedback-form.vue',
})

// 审计疑点列表
routerService.routeInFrame('audit-suspects-list', {
  component: './suspects/audit-suspects-list.vue',
})

// 审计疑点管理管理-授权申请表单
flowService.addFlowForm('vue:audit/suspects/iamAuditSuspects', './suspects/audit-suspects-form.vue')

// 审计疑点列表
routerService.routeInFrame('auditSuspectsForm', {
  component: './suspects/audit-suspects-form.vue',
})

// 整改延期申请单
routerService.routeInFrame('audit-delay-form', {
  component: './question/audit-delay-form.vue',
})

// 整改销号列表
routerService.routeInFrame('iam-audit-rectify-list', {
  component: './work/rectify/iam-audit-rectify-list.vue',
})
// 整改销号表单
routerService.routeInFrame('iam-audit-rectify-form', {
  component: './work/rectify/iam-audit-rectify-form.vue',
})
// 整改提醒
routerService.routeInFrame('audit-remind-config', {
  component: './remindconfig/audit-remind-config.vue',
})

// 审计发现问题报表
routerService.routeInFrame('audit-find-report', {
  component: './work/report/find/report/audit-find-report.vue',
})

// 审计报告报表
routerService.routeInFrame('audit-report', {
  component: './work/report/audit-report.vue',
})
// 项目统计
routerService.routeInFrame('audit-statistics-project', {
  component: './statistics/audit-statistics-project.vue',
})
// 发现统计
routerService.routeInFrame('audit-statistics-find', {
  component: './statistics/audit-statistics-find.vue',
})
// 覆盖统计
routerService.routeInFrame('audit-statistics-fg-config', {
  component: './statistics/audit-statistics-fg-config.vue',
})

// 发现统计明细
routerService.routeInFrame('audit-statistics-find-list', {
  component: './statistics/audit-statistics-find-list.vue',
})
// 扩展图标展示
routerService.routeInFrame('audit-icons-list', {
  component: './auditIcons/audit-icons-list.vue',
})

// 扩展图标展示
routerService.routeInFrame('audit-icons-list', {
  component: './auditIcons/audit-icons-list.vue',
})
// 项目执行情况
routerService.routeInFrame('audit-implement-status', {
  component: './statistics/audit-implement-status.vue',
})
// 扩展图标展示
routerService.routeInFrame('audit-icons-list', {
  component: './auditIcons/audit-icons-list.vue',
})
// 整改情况统计-按审计项目查询
routerService.routeInFrame('audit-project-rectification', {
  component: './statistics/audit-project-rectification.vue',
})
// 整改情况统计-按整改单位查询
routerService.routeInFrame('audit-project-rectification-unit', {
  component: './statistics/audit-project-rectification-unit.vue',
})
// 机构人员统计-机构基本情况
routerService.routeInFrame('audit-personnel-statistics', {
  component: './statistics/audit-personnel-statistics.vue',
})
// 机构人员统计-人员工作情况
routerService.routeInFrame('audit-personnel-work-statistics', {
  component: './statistics/audit-personnel-work-statistics.vue',
})
// 审计分析报表-审计项目完成情况
routerService.routeInFrame('audit-project-completion-status', {
  component: './statistics/audit-project-completion-status.vue',
})
// 审计分析报表-审计问题整改明细台账
routerService.routeInFrame('audit-problem-rect-item', {
  component: './statistics/audit-problem-rect-item.vue',
})

// 审计分析报表-审计项目完成情况及成果统计表
routerService.routeInFrame('audit-project-rect-statistics', {
  component: './statistics/audit-project-rect-statistics.vue',
})

// 审计分析报表-企业上报报表
routerService.routeInFrame('audit-enterprise-reports', {
  component: './statistics/audit-enterprise-reports.vue',
})
// 决策支持中心
routerService.routeInFrame('iam-audit-decision-support-center', {
  component: './dsc/iam-audit-dsc-main.vue',
})

// 决策支持中心-人员列表
routerService.routeInFrame('iam-audit-dsc-userbase-list', {
  component: './dsc/components/iam-audit-dsc-userbase-list.vue',
})

// 决策支持中心-审计发现列表
routerService.routeInFrame('iam-audit-dsc-find-list', {
  component: './dsc/components/iam-audit-dsc-find-list.vue',
})
// 决策支持中心-项目信息列表
routerService.routeInFrame('iam-audit-dsc-project-list', {
  component: './dsc/components/iam-audit-dsc-project-list.vue',
})
// 决策支持中心-整改问题列表
routerService.routeInFrame('iam-audit-dsc-rectify-list', {
  component: './dsc/components/iam-audit-dsc-rectify-list.vue',
})
// 首页
routerService.route('/audit-home', {
  component: './home/audit-home.vue',
})
// 详情页面
routerService.route('/iam-audit-home-three', {
  component: './home/iam-audit-home-view.vue',
})
// 阅读者列表
routerService.route('/iam-audit-reader-list', {
  component: './home/xm-audit-reader-list.vue',
})

routerService.route('/sd-home', {
  component: null,
  redirect: '/sd-frame/iam-content',
})

routerService.routeInFrame('iam-content', {
  component: './workbench/iam-frame-content.vue',
})

// 在办案件
routerService.routeInFrame('law-all-case-list', {
  component: './workbench/case/law-all-case-list.vue',
})

// 在办纠纷
routerService.routeInFrame('law-all-dispute-list', {
  component: './workbench/dispute/law-all-dispute-list.vue',
})

// 审计世界地图
routerService.routeInFrame('audit-worldmap-form', {
  component: './map/xm-audit-worldmap.vue',
})

// 审计中国地图
routerService.routeInFrame('audit-chinamap-form', {
  component: './map/xm-audit-chinamap.vue',
})

routerService.routeInFrame('xm-audit-mapcoverage-list', {
  component: './map/xm-audit-mapcoverage-list.vue',
})

// 审计地图页面
routerService.routeInFrame('xm-audit-map-support-center', {
  component: './map/xm-audit-map-main.vue',
})

// 审计画像1-企业经营画像
routerService.routeInFrame('xm-audit-hx-qyjyhx', {
  component: './auditsjtx/xm-audit-tx-1-qyjyhx.vue',
})

// 审计画像2-审计监督画像
routerService.routeInFrame('xm-audit-hx-sjjdhx', {
  component: './auditsjtx/xm-audit-tx-2-sjjdhx.vue',
})

// 审计画像3-流程领域风险画像
routerService.routeInFrame('xm-audit-hx-lclyfxhx', {
  component: './auditsjtx/xm-audit-tx-3-lclyfxhx.vue',
})

// 主数据管理-组织管理
routerService.routeInFrame('master-data-management', {
  component: './masterdata/master-data-list.vue',
})

// 主数据管理-关联操作记录
routerService.routeInFrame('master-data-operate', {
  component: './masterdata/master-data-operate.vue',
})

// 数据集市
routerService.routeInFrame('data-market', {
  component: './dataMarket/data-market.vue',
})

// 数据权限管理
routerService.routeInFrame('data-rule', {
  component: './dataMarket/data-rule-manage.vue',
})

// 数据权限管理-数据权限申请
routerService.routeInFrame('data-rule-apply', {
  component: './dataMarket/data-rule-apply.vue',
})

// 数据权限管理-数据授权记录
routerService.routeInFrame('data-record', {
  component: './dataMarket/data-record.vue',
})

// 数据权限管理-数据授权记录详情
routerService.routeInFrame('data-record-info', {
  component: './dataMarket/data-record-info.vue',
})

// 超级审搜
routerService.routeInFrame('super-search', {
  component: './superSearch/index.vue',
})

// 审计模型信息管理-模型信息管理
routerService.routeInFrame('audit-model-list', {
  component: './model/audit-model-list.vue',
})

// 审计模型信息管理-模型信息
routerService.routeInFrame('audit-model-form', {
  component: './model/audit-model-form.vue',
})

routerService.routeInFrame('audit-model-view', {
  component: './model/audit-model-forms.vue',
})

// 审计模型信息管理-模型信息发布
routerService.routeInFrame('audit-model-sqapply', {
  component: './model/audit-model-sqapply.vue',
})

// 审计模型信息管理-模型信息共享
routerService.routeInFrame('audit-model-gxapply', {
  component: './model/audit-model-gxapply.vue',
})

// 审计模型信息管理-模型信息市场
routerService.routeInFrame('audit-model-market', {
  component: './model/audit-model-market.vue',
})
// 模型分类管理
routerService.routeInFrame('audit-model-class', {
  component: './model/audit-model-class.vue',
})
// 发布vue:audit/sqapply/iamModelPublishApply
flowService.addFlowForm('vue:audit/sqapply/iamModelPublishApply', './model/audit-model-sqapply.vue')
// 共享
flowService.addFlowForm('vue:audit/sqapply/iamModelShareApply', './model/audit-model-gxapply.vue')
// flowService.addFlowForm(
//   'vue:audit/sqapply/iamQuestionExamine',
//   // './riskLibrary/audit-summarry-from.vue'
//   './riskLibrary/audit-issued-form.vue'
// )
flowService.addFlowForm(
  'vue:audit/sqapply/iamQuestionExamine',
  './riskLibrary/audit-issued-form.vue'
)
// 审计模型信息管理-仪表板
// audit-fixed-list
routerService.routeInFrame('audit-fixed-list', {
  component: './maintain/audit-fixed-list.vue',
})

// 审核画像-企业经营画像-公司及领导情况
routerService.routeInFrame('audit-company-situation', {
  component: './portrait/audit-company-situation.vue',
})
// 审核画像-企业经营画像-审计覆盖情况
routerService.routeInFrame('audit-cover-situation', {
  component: './portrait/audit-cover-situation.vue',
})
// 审核画像-企业经营画像-财务管理
routerService.routeInFrame('audit-financial-detail', {
  component: './portrait/audit-financial-detail.vue',
})
// 模型数据查看
routerService.routeInFrame('audit-sq-record', {
  component: './maintain/audit-sq-record.vue',
})
// 审计风险-看板
routerService.routeInFrame('audit-risk-view', {
  component: './riskLibrary/audit-risk-view.vue',
})
// 审前报表
routerService.routeInFrame('audit-pre-report', {
  component: './report/audit-pre-report.vue',
})

// 风险库查看-审计问题总汇
routerService.routeInFrame('audit-view-sum', {
  component: './riskLibrary/audit-view-sum.vue',
})
// 风险库查看-审计问题总汇-关注类
routerService.routeInFrame('audit-view-detail', {
  component: './riskLibrary/audit-view-detail.vue',
})
// 风险库查看-审计问题总汇-整改类
routerService.routeInFrame('audit-view-change', {
  component: './riskLibrary/audit-view-change.vue',
})
// 指标分类audit-zb-list
routerService.routeInFrame('audit-zb-list', {
  component: './portrait/audit-zb-list.vue',
})
// 企业经营画像-财务对比
// audit-contrast-view
routerService.routeInFrame('audit-contrast-view', {
  component: './portrait/audit-contrast-view.vue',
})

// 企业经营画像-生产管理audit-production-detail
routerService.routeInFrame('audit-production-detail', {
  component: './portrait/audit-production-detail.vue',
})

// 企业经营画像-采购管理 audit-purchase-detail
routerService.routeInFrame('audit-purchase-detail', {
  component: './portrait/audit-purchase-detail.vue',
})
// 企业经营画像-薪酬管理 audit-salary-detail
routerService.routeInFrame('audit-salary-detail', {
  component: './portrait/audit-salary-detail.vue',
})
// 企业经营画像-采购管理 audit-view-board
routerService.routeInFrame('audit-view-board', {
  component: './portrait/audit-view-board.vue',
})

// 风险库-问题详情
routerService.routeInFrame('audit-risk-detail', {
  component: './riskLibrary/audit-risk-detail.vue',
})

// 流程领域风险画像
// audit-process-risk
routerService.routeInFrame('audit-process-risk', {
  component: './riskLibrary/audit-process-risk.vue',
})
// 审计监督画像
// audit-supervise-view
routerService.routeInFrame('audit-supervise-view', {
  component: './riskLibrary/audit-supervise-view.vue',
})
