
/* eslint-disable */
// sd-skip-auto-import
import axios from"@/common/services/axios-instance";import extensionUtil from"@/common/services/extension-util";import customFormulas from"./custom-formulas.js";const formulas=[{data:"PRODUCT",label:"乘积",dataType:"number",params:[{data:"formalParameter",label:"数值字段",dataType:"number",spread:true}],desc:{concept:"返回一组数值的乘积，可以计算多个数值字段的和，或子表C列的值等于A列与B列的乘积",use:"乘积（数值字段，数值字段，）；乘积（子表.数值字段，子表.数值字段）",exam:"子表.加权得分=乘积（子表.得分，子表.权重）"}},{data:"SUM",label:"求和",dataType:"number",params:[{data:"formalParameter",label:"数值字段",dataType:"number",spread:true}],desc:{concept:"返回一组数值的和，可以计算多个数值字段，或子表某一列的和",use:"求和（数值字段，数值字段，）；求和（子表.数值字段）",exam:"总分=求和（子表.分数）"}},{data:"COUNT",label:"计数",dataType:"number",params:[{data:"formalParameter",label:"多值字段",dataType:"any[]"}],desc:{concept:"返回一组数值或选项的个数，可以计数子表某一列数值的个数，或单选/复选/下拉选项的个数",use:"计数（子表.数值字段）；计数（单选框）",exam:"计数=（子表1），计算子表共有多少条数据"}},{data:"AVERAGE",label:"平均值",dataType:"number",params:[{data:"formalParameter",label:"数值字段",dataType:"number",spread:true}],desc:{concept:"返回一组数值的平均值，可以计算多个数值字段的平均值，或子表某一列的平均值",use:"平均值（数值字段，数值字段，）；平均值（子表.数值字段）",exam:"平均分=平均值（子表.得分）"}},{data:"MAX",label:"最大值",dataType:"number",params:[{data:"formalParameter",label:"数值字段",dataType:"number",spread:true}],desc:{concept:"返回一组数值的最大值，可以计算多个数值字段的最大值，或子表某一列的最大值。",use:"最大值（数值字段，数值字段，）；最大值（子表.数值字段）",exam:"最高分=最大值（子表.得分）"}},{data:"MIN",label:"最小值",dataType:"number",params:[{data:"formalParameter",label:"数值字段",dataType:"number",spread:true}],desc:{concept:"返回一组数值的最小值，可以计算多个数值字段的最小值，或子表某一列的最小值",use:"最小值（数值字段，数值字段，）；最小值（子表.数值字段）",exam:"最低分=最小值（子表.得分）"}},{data:"IMSUB",label:"相减",dataType:"number",params:[{data:"formalParameter",label:"数值字段",dataType:"number"},{data:"formalParameter",label:"数值字段",dataType:"number"}],desc:{concept:"返回两个数值的差，可以计算两个数值字段的差，或子表C列的值等于A列减去B列的差。",use:"相减（数值字段，数值字段）；相减（子表.数值字段，子表.数值字段）,先添加被减数，再添加减数。",exam:"未收款金额=相减（合同总金额，已收款金额）。"}},{data:"QUOTIENT",label:"相除",dataType:"number",params:[{data:"formalParameter",label:"数值字段",dataType:"number"},{data:"formalParameter",label:"数值字段",dataType:"number"}],desc:{concept:"返回两个数值的商，可以计算两个数值字段的商，或子表C列的值等于A列与B列的商。",use:"相除（数值字段，数值字段）；相除（子表.数值字段，子表.数值字段），先添加被除数，再添加除数。",exam:"平均分=相除（总分，人数）"}},{data:"GETGROUPBYUSER",label:"获取用户部门",dataType:"group[]",params:[{data:"formalParameter",label:"用户字段",dataType:"user[]"}],desc:{concept:"获取指定用户所在部门",use:"获取用户部门（用户字段）",exam:"部门=获取用户部门（张三），获取张三所在部门"}},{data:"CONCATENATE",label:"字符串拼接",dataType:"string",params:[{data:"formalParameter",label:"字符字段",dataType:"string",spread:true}],desc:{concept:"将多个字符连接起来并作为结果返回，字符可以是文本字段。文本框可使用该函数。",use:"字符串拼接（文本框，多行文本，）",exam:"字符串拼接（“开开”，“心心”）= “开开心心”"}},{data:"CONCAT",label:"数组拼接",dataType:"any[]",params:[{data:"formalParameter",label:"拼接字段",dataType:"any",spread:true}]},{data:"GETUSERINFO",label:"获取用户信息",dataType:"string",params:[{data:"formalParameter",label:"用户字段",dataType:"user[]"},{data:"constParameter",label:"常量",dataType:"string",selectListItem:[{data:"idcard",label:"身份证"},{data:"mobile",label:"手机"},{data:"phone",label:"电话"},{data:"lev",label:"职务"},{data:"room",label:"地址"},{data:"account",label:"账号"},{data:"pinyin",label:"拼音"},{data:"name",label:"姓名"},{data:"dept",label:"所在部门"},{data:"deptCode",label:"部门编码"},{data:"email",label:"电子邮件"}],actual:{data:"idcard",label:"身份证"}}],desc:{concept:"获取指定用户的某一基本信息（所在部门、手机号等）",use:"获取用户信息（用户字段，基本信息下拉选项）",exam:"申请人手机号=获取用户信息（申请人，手机号）"}},{data:"GETGROUPINFO",label:"获取部门信息",dataType:"string",params:[{data:"formalParameter",label:"部门字段",dataType:"group[]"},{data:"constParameter",label:"常量",dataType:"string",selectListItem:[{data:"name",label:"部门名称"},{data:"id",label:"部门编号"}],actual:{data:"name",label:"部门名称"}}],desc:{concept:"获取指定部门的某一基本信息（部门名称、部门编号等）",use:"获取部门信息（部门字段，部门名称等）",exam:"获取部门信息（部门字段，部门名称）"}},{data:"TEXT",label:"数值转字符串",dataType:"string",params:[{data:"formalParameter",label:"数值字段",dataType:"number"}],desc:{concept:"将数值型字段的值转为字符型",use:"数值转字符串（数值字段）",exam:"数值转字符串（年度）"}},{data:"MONEYSTRING",label:"金额大写",dataType:"string",params:[{data:"formalParameter",label:"数值字段",dataType:"number"}],desc:{concept:"用大写的形式展示金额",use:"金额大写（数值字段）",exam:"金额大写（合同总额）"}},{data:"EXACT",label:"字符相等",dataType:"boolean",params:[{data:"formalParameter",label:"字符字段",dataType:"string"},{data:"formalParameter",label:"字符字段",dataType:"string"}],desc:{concept:"比较两个字符是否相等，字符可以是文本/单选/下拉字段，或常量（选项或输入文字），返回逻辑值（“真”，“假”）",use:"字符相等（单选框，常量），双击输入框可添加常量",exam:"字符相等（是否上会，“是”），当【是否上会】选中”是“时，返回“真”。可用于设置满足此条件时显示某字段"}},{data:"EXACTNUM",label:"数值相等",dataType:"boolean",params:[{data:"formalParameter",label:"数值字段",dataType:"number"},{data:"formalParameter",label:"数值字段",dataType:"number"}],desc:{concept:"比较两个数值是否相等",use:"数值相等（数值框，数值框）",exam:"数值相等（数值一，数值二），当两个数值相等时返回“真”"}},{data:"AND",label:"所有条件为真",dataType:"boolean",params:[{data:"formalParameter",label:"逻辑值",dataType:"boolean",spread:true}],desc:{concept:"“AND”函数，判断多个条件同时满足时返回“真”，输入、输出均为逻辑值（“真”，“假”）",use:"所有条件为真（相等（），包含（），逻辑值，）",exam:"所有条件为真（相等（单选框，选项1），包含（复选框，选项1）），当【单选框】选中”选项1“，【复选框】选择”选项1“时，返回“真”。可用于设置同时满足以上条件时显示某字段"}},{data:"OR",label:"任一条件为真",dataType:"boolean",params:[{data:"formalParameter",label:"逻辑值",dataType:"boolean",spread:true}],desc:{concept:"“OR”函数, 判断多个条件中有任一满足时即返回“真“，输入、输出均为逻辑值",use:"任一条件为真（相等（），相等（），逻辑值，）",exam:"任一条件为真（相等（单选框，选项1），相等（单选框，选项4）），当【单选框】选中”选项1“或”选项4“时，均返回“真”。可用于设置满足任一条件时显示某字段"}},{data:"NOT",label:"不满足条件",dataType:"boolean",params:[{data:"formalParameter",label:"逻辑值",dataType:"boolean"}],desc:{concept:"“NOT”函数，判断不满足某个条件时返回“真”，输入、输出均为逻辑值（“真”，“假“）",use:"不满足条件（相等（），相等（），逻辑值，）",exam:"不满足条件（相等（下拉框，选项1）），当【单选框】选中”选项1“时，返回”假“，选中其他选项时，返回”真“。可用于设置不满足某一条件时显示某字段"}},{data:"INCLUDES",label:"字符包含",dataType:"boolean",params:[{data:"formalParameter",label:"字符字段",dataType:"string"},{data:"formalParameter",label:"字符字段",dataType:"string"}],desc:{concept:"判断复选框是否包含某个选项，返回逻辑值（“真”，“假”）",use:"字符包含（复选框，常量）",exam:"包含（复选框，选项1），当【复选框】选中”选项1”时，返回“真”。可用于设置满足此条件时显示某字段"}},{data:"GETVALUEBYTREELEVEL",label:"获取指定层级节点",dataType:"string",params:[{data:"formalParameter",label:"字符字段",dataType:"string"},{data:"formalParameter",label:"数值字段",dataType:"number"}],desc:{concept:"获取树形组件某一层级节点的值",use:"获取指定层级节点（树选择器，数值字段）",exam:"合同二类名称=获取指定层级节点（合同类别，2）,该字段如果也是树选择器，则要同步配置显示层级与公式数值参数相同"}},{data:"NETWORKDAYS",label:"工作日相差天数",dataType:"number",params:[{data:"formalParameter",label:"日期字段",dataType:"date"},{data:"formalParameter",label:"日期字段",dataType:"date"},{data:"formalParameter",label:"用户字段",dataType:"user[]"}],desc:{concept:"计算两个日期字段的差值，按选择的用户的工作日历计算，非工作日不纳入",use:"日期查自然日（日期1，日期2，用户）",exam:"请假天数=日期差工作日（请假开始日期，请假结束日期，张三）"}},{data:"DAYS",label:"自然日相差天数",dataType:"number",params:[{data:"formalParameter",label:"日期字段",dataType:"date"},{data:"formalParameter",label:"日期字段",dataType:"date"}],desc:{concept:"计算两个日期字段的差值，按自然日计算",use:"日期差自然日（日期1，日期2）",exam:"出差天数=日期差自然日（出差开始日期，出差结束日期）"}},{data:"GETCURRENTUSER",label:"获取当前用户",dataType:"user",params:[],desc:{concept:"获取指定用户的某一基本信息（所在部门、手机号等）",use:"获取用户信息（用户字段，基本信息下拉选项）",exam:"申请人手机号=获取用户信息（申请人，手机号）"}},{data:"USERINCLUDEROLE",label:"用户是否包含角色",dataType:"boolean",params:[{data:"formalParameter",label:"用户字段",dataType:"user"},{data:"formalParameter",label:"字符字段",dataType:"string"}],desc:{concept:"判断当前用户是否属于某一个角色",use:"用户是否包含角色（用户字段，字符字段），此处用户字段仅支持函数：获取当前用户，字符字段需要输入角色编码",exam:"值=用户是否包含角色（获取当前用户（），G-1_test_zgsws），获取当前用户是否属于总公司文书"}},{data:"IF",label:"如果",dataType:"any",params:[{data:"formalParameter",label:"条件",dataType:"boolean"},{data:"formalParameter",label:"满足条件返回值",dataType:"any"},{data:"formalParameter",label:"不满足条件返回值",dataType:"any"}],desc:{concept:"如果函数，判断某个条件，如果满足条件返回满足条件的返回值，不满足条件则返回不满足条件的返回值",use:"如果（条件，数值/字符/公式，数值/字符/公式）",exam:"数值=如果（字段是否为空（字段），1，2） 当字段是空时，数值=1，当字段非空时，数值=2"}},{data:"ISBLANK",label:"是否为空",dataType:"boolean",params:[{data:"formalParameter",label:"任意字段",dataType:"any"}],desc:{concept:"该函数用来判断当前字段值是否为空，如果为空返回“真”",use:"是否为空（任意字段）",exam:"数值=如果（字段是否为空（字段），1，2） 当字段是空时，数值=1，当字段非空时，数值=2"}},{data:"GT",label:"大于",dataType:"boolean",params:[{data:"formalParameter",label:"数值字段",dataType:"number"},{data:"formalParameter",label:"数值字段",dataType:"number"}],desc:{concept:"比较数值一是否大于数值二",use:"大于（数值框，数值框）",exam:"大于（数值一，数值二），当数值一大于数值二返回“真”"}},{data:"LT",label:"小于",dataType:"boolean",params:[{data:"formalParameter",label:"数值字段",dataType:"number"},{data:"formalParameter",label:"数值字段",dataType:"number"}],desc:{concept:"比较数值一是否小于数值二",use:"小于（数值框，数值框）",exam:"小于（数值一，数值二），当数值一小于数值二返回“真”"}},{data:"GETUSERBYACCOUNT",label:"账号获取用户",dataType:"user[]",params:[{data:"formalParameter",label:"字符字段",dataType:"string"}],desc:{concept:"通过用户账号获取到当前用户的名称",use:"账号获取用户（字符字段）",exam:"用户姓名=账号获取用户（12345），获取产品部所在公司的名称"}},{data:"CURRENTTIME",label:"获取当前时间",dataType:"date",params:[],desc:{concept:"获取当前日期，页面刷新后生效",use:"获取当前时间（）",exam:"提交时间=获取当前时间（）"}},{data:"DATEAFTER",label:"推算日期",dataType:"date",params:[{data:"formalParameter",label:"日期字段",dataType:"date"},{data:"formalParameter",label:"数值字段",dataType:"number"},{data:"constParameter",label:"常量",dataType:"any",selectListItem:[{data:"day",label:"天"},{data:"hour",label:"小时"},{data:"minute",label:"分钟"}],actual:{data:"day",label:"天"}}],desc:{concept:"根据一个已知时间，推算增加一定天数、小时、分钟后的时间",use:"推算日期（日期字段，数值字段，时间单位）",exam:"提交时间=推算日期（当前日期，50，天）"}}];const formula=()=>axios.post("api/framework/v1/level-manager/list",{columns:"name,code",maxResults:-1,orderBy:"index asc",expressions:[{dataType:"str",name:"type",op:"eq",stringValue:"G"}]}).then((a=>{const e=a.data.datas.map((a=>({data:a.code,label:a.name})));const t=JSON.parse(JSON.stringify(formulas));t.push({data:"GETGROUPBYLEVEL",label:"按组织级别获取部门",dataType:"group[]",params:[{data:"formalParameter",label:"部门",dataType:"group[]"},{data:"constParameter",label:"常量",dataType:"string",selectListItem:e,actual:e?.[0]}],desc:{concept:"获取部门所在的组织层级",use:"按组织级别获取部门（部门，部门层级下拉框）",exam:"部门名称=按组织级别获取部门（产品部，公司），获取产品部所在公司的名称；部门参数要选择部门"}});const r=extensionUtil.parse(require.context("../../src/form-designer",false,/\.xxx$/,"lazy"),require.context("../../src_product",true,/_form-designer\/formulas\/.*.js$/,"lazy"),require.context("../../src_custom/_form-designer/formulas",true,/\.js$/,"lazy"));return customFormulas(r).then((a=>t.concat(a)))}));export default formula;